#!/bin/bash

uuid=`/usr/sbin/dmidecode -s system-uuid | tr 'A-Z' 'a-z'`

check_file(){
    if [[ -f "/usr/sbin/ctcm_agentd" ]]; then
        mv "/usr/sbin/ctcm_agentd" "/usr/sbin/ctcm_agentd_bak"
    fi

    cp ./ctcm-agent.service /lib/systemd/system/ctcm-agent.service 
    cp ./ctcm_agentd /usr/sbin/ctcm_agentd
    chmod +x /usr/sbin/ctcm_agentd
    mkdir -p /etc/ctcm/scripts ; mkdir -p /etc/ctcm/ctcm_agentd.d ; mkdir -p /var/log/ctcm/ ;  
}
copy_conf(){
        /bin/cp ./ctcm_agentd.conf /etc/ctcm/ctcm_agentd.conf && sed -ri "s#^Hostname=.*#Hostname=${uuid}#g" /etc/ctcm/ctcm_agentd.conf
        /bin/cp -fr ./scripts/* /etc/ctcm/scripts/ && chmod -R +x /etc/ctcm/scripts/
}
start_server(){
    systemctl enable ctcm-agent.service && systemctl restart ctcm-agent.service

    count=`ps -ef|grep /usr/sbin/ctcm_agentd|grep -v 'grep'|wc -l`
    if [ $count -eq  0 ];then
        if [[ -f "/usr/sbin/ctcm_agentd_bak" ]]; then
            mv "/usr/sbin/ctcm_agentd_bak" "/usr/sbin/ctcm_agentd"
            systemctl restart ctcm-agent.service
        fi
        echo -e "ERROR: ${time} Install Agent Server Failed"
        exit 1
    fi
}
main(){
    check_file
    copy_conf
    start_server
}

main
