#!/usr/bin/python
# -*- coding: UTF-8 -*-

import json
import sys
import os
import re
#from collections import OrderedDict
#import configparser
from shutil import copy, copy2

class Diskagent_process_register(object):
    def __init__(self):
        def get_diskuuiddata():
            lines = open("/proc/partitions").readlines()[2:]
            partitions = set([line.split()[-1] for line in lines if not line.strip()[-1].isdigit()])
            diskuuiddata = []
            disknamedata = []
            for disk in partitions:
                if disk.startswith('sd') or disk.startswith('nvme'):
                    try:
                        diskuuidinfo=os.popen('udevadm info --query=all --name=%s | grep SERIAL_SHORT' %(disk)).readlines()[0].strip('\n')
                        diskuuiddata.append(diskuuidinfo[diskuuidinfo.index('=')+1:])
                        disknamedata.append(disk)
                    except IndexError as result:
                        os.popen('udevadm control --reload-rules && udevadm trigger')
                elif disk.startswith('vd'):
                    try:
                        diskuuidinfo=os.popen('udevadm info --query=all --name=%s | grep SERIAL' %(disk)).readlines()[0].strip('\n')
                        diskuuiddata.append(diskuuidinfo[diskuuidinfo.index('=')+1:])
                        disknamedata.append(disk)
                    except IndexError as result:
                        os.popen('udevadm control --reload-rules && udevadm trigger')

            return diskuuiddata, disknamedata

        self.currnetdiskuuid, self.currnetdiskname= get_diskuuiddata()
        self.base_start_cmd = '/usr/sbin/ctcm_agentd -c '


        self.base_pid_file_path = 'PidFile=/var/run/ctcm_agentd.pid'
        self.base_log_file_path = 'LogFile=/var/log/ctcm/ctcm_agentd.log'
        self.base_vm_uuid = "dmidecode -s system-uuid | tr 'A-Z' 'a-z' "

        self.srcconf_base = '/etc/ctcm/ctcm_agentd.conf'
        self.base_pid_file = '/var/run/ctcm_agentd.pid'
        self.base_log_file = '/var/log/ctcm/ctcm_agentd.log'

    def modify_conf_line(self, confline, postfix, diskuuid,delimiter):
        return confline.rstrip(postfix) + delimiter + diskuuid + postfix

    def kill_olddiskagent_process(self):
        check_oldprocess_command = "ps -ef | grep ctcm_agentd# | grep \-v grep"
        # old_diskuuid_list = [oldprocess_info.split()[-1].rstrip('.conf')[oldprocess_info.split()[-1].rfind('#') + 1:] for oldprocess_info in os.popen(check_oldprocess_command).readlines()]
        old_diskuuid_list = [re.findall(r"#(.+?).conf", oldprocess_info.split()[-1])[0] for oldprocess_info in os.popen(check_oldprocess_command).readlines()]

        for old_diskuuid in old_diskuuid_list:
            if old_diskuuid not in self.currnetdiskuuid:
                get_oldprocessppid_command = "ps -ef | grep ctcm_agentd#%s | grep -v grep | awk {'print $2'}" %(old_diskuuid)
                old_processppid = os.popen(get_oldprocessppid_command).read().split()[0]

                old_dstconf_base_path = self.modify_conf_line(self.srcconf_base, '.conf',old_diskuuid, '#')
                old_diskagent_pid_file = self.modify_conf_line(self.base_pid_file, '.pid', old_diskuuid, '#')
                old_diskagent_log_file = self.modify_conf_line(self.base_log_file, '.log', old_diskuuid, '#')
                os.system('pkill -9 -P %s'%(old_processppid))
                os.remove(old_dstconf_base_path)
                os.remove(old_diskagent_log_file)
                os.remove(old_diskagent_pid_file)

        return list(set(self.currnetdiskuuid) - set(old_diskuuid_list))
    def check_exist_disk_agent(self):
        diskuuid_process = self.kill_olddiskagent_process()
        for diskuuid in diskuuid_process:
            check_process_command =  'ps -ef | grep ctcm_agentd#%s.conf | grep -v grep'%(diskuuid)
            if os.popen(check_process_command).read() == '':
                self.modify_agentconf_startprocess(diskuuid)

        print(dict(zip(self.currnetdiskuuid, self.currnetdiskname)))

    def modify_agentconf_startprocess(self, diskuuid):
        dstconf_base_path = self.modify_conf_line(self.srcconf_base, '.conf', diskuuid, '#')
        diskagent_pid_file = self.modify_conf_line(self.base_pid_file_path, '.pid', diskuuid, '#')
        diskagent_log_file = self.modify_conf_line(self.base_log_file_path, '.log', diskuuid, '#')

        #cp /etc/zabbix/zabbix_agentd.conf /etc/zabbix/zabbix_agentd#uuid.conf
        copy2(self.srcconf_base, dstconf_base_path)

        #Assigning value to sed_command_string
        vm_uuid = os.popen("dmidecode -s system-uuid | tr 'A-Z' 'a-z';").read().rstrip('\n')
        hostname = vm_uuid + '_' + diskuuid
        sed_command = 'sed -i "s?PidFile=/var/run/ctcm_agentd.pid?%s?g" %s; ' \
                      'sed -i "s?LogFile=/var/log/ctcm/ctcm_agentd.log?%s?g"  %s; ' \
                      'sed -i "s?Hostname=%s?Hostname=%s?g" %s; ' \
                      'sed -i "s?HostMetadata=virtual_server?HostMetadata=virtual_disk?g" %s; ' \
                     % (diskagent_pid_file,dstconf_base_path, diskagent_log_file, dstconf_base_path, vm_uuid, hostname,
                        dstconf_base_path,dstconf_base_path)
        os.system(sed_command)

        diskagent_start_cmd = self.base_start_cmd + dstconf_base_path
        os.popen(diskagent_start_cmd)

def main():
    diskagent_process = Diskagent_process_register()
    diskagent_process.check_exist_disk_agent()

if __name__ == '__main__':
    main()
