# -*- coding: UTF-8 -*-

'''
nvidia-smi
Fri Jul 19 17:45:27 2019
+-----------------------------------------------------------------------------+
| NVIDIA-SMI 412.16       Driver Version: 412.16       CUDA Version: 10.0     |
|-------------------------------+----------------------+----------------------+
| GPU  Name            TCC/WDDM | Bus-Id        Disp.A | Volatile Uncorr. ECC |
| Fan  Temp  Perf  Pwr:Usage/Cap|         Memory-Usage | GPU-Util  Compute M. |
|===============================+======================+======================|
|   0  GRID V100-2Q       WDDM  | 00000000:00:0C.0 Off |                  N/A |
| N/A   N/A    P0    N/A /  N/A |    464MiB /  2048MiB |      0%      Default |
+-------------------------------+----------------------+----------------------+

+-----------------------------------------------------------------------------+
| Processes:                                                       GPU Memory |
|  GPU       PID   Type   Process name                             Usage      |
|=============================================================================|
|    0       536    C+G   C:\Windows\Explorer.EXE                    N/A      |
|    0      1844    C+G   Insufficient Permissions                   N/A      |
|    0      1944    C+G   Insufficient Permissions                   N/A      |
|    0      4352    C+G   Insufficient Permissions                   N/A      |
+-----------------------------------------------------------------------------+
'''

'''
return :
-1           : cmd not found
-2           : cmd err
nonnegative  : ok 
'''


import os
import sys


def gpu_info(gpuNum, item):
    gpulines=os.popen('nvidia-smi 2> /dev/null').readlines()
    if not gpulines:
        return -1

    gpuinfo = {}
    try:
        infos = gpulines[7+3*gpuNum+1].split()
        gpuinfo['Perf'] = infos[3]
        gpuinfo['MemUsage'] = round( ( float(infos[8][:-3])/int(infos[10][:-3]) )*100, 2 )
        gpuinfo['GpuUtil'] = round(float(infos[12][:-1]), 2)
    except:
        return -2
    else:
        return gpuinfo[item]


def main(gpuNum=None, item=None):
    print(gpu_info(gpuNum, item))


if __name__ == '__main__':
    opts = ['Perf', 'MemUsage', 'GpuUtil']
    if len(sys.argv) != 3 or sys.argv[2] not in opts or not sys.argv[1].isdigit():
        print("arg err!(get_gpu_info.py 0|1|2... Perf|MemUsage|GpuUtil)")
        sys.exit()
    
    main(gpuNum=int(sys.argv[1]), item=sys.argv[2])
