# -*- coding: UTF-8 -*-

'''
nvidia-smi -L
GPU 0: GeForce 940MX (UUID: GPU-c26f0b00-e5e2-e3e1-8287-d806fece4c98)
'''


import os
import sys
import json


def gpu_num():
    gpulines=os.popen('nvidia-smi -L 2> /dev/null').readlines()
    if not gpulines:
        return -1
        
    if not gpulines[0].startswith('GPU'):
        return 0
    
    return len(gpulines)

def main():
    discoverinfo = {}
    discoverinfo['data'] = []
    
    gpunum = gpu_num()
    if -1 == gpunum:
        print(json.dumps(discoverinfo))
        exit()
    
    
    for i in range(gpunum):
        discoverinfo['data'].append( {"{#GPUINDEX}":"%d"%i} )

    print(json.dumps(discoverinfo))
  
if __name__ == '__main__': 
    main()