# -*- coding: UTF-8 -*-

'''
# cat /proc/net/dev
Inter- |   Receive                                                         |  Transmit
 face  |bytes         packets    errs drop fifo frame compressed multicast |bytes       packets      errs drop fifo colls carrier compressed
  eth0: 809182345520 6654395698  0    0    0     0          0    3657326   633671446754 6425523937   0    0    0     0       0          0
  eth1: 239566576    1561758     0    0    0     0          0         0    1129228143   1361892      0    0    0     0       0          0
    lo: 414798643602 882135622   0    0    0     0          0         0    414798643602 882135622    0    0    0     0       0          0

'''

import time
import os

PROCPATH="/proc/net/dev"
SLEEPTIME=2
REALNETVER="virtio_net"


def is_real_netcard(cardName):
    versionLine = os.popen("ethtool -i %s 2>/dev/null"%cardName).readline()
    if not versionLine.startswith("driver"):
        return False
        
    if versionLine.split(':')[1].strip('\n').strip() == REALNETVER:
        return True
    else:
        return False
    
        

def readproc():
    alldata = 0
    linenum = 1
    
    with open(PROCPATH) as fp:
        for line in fp:
            if linenum < 3:
                linenum += 1
                continue

            if is_real_netcard(line.split(':')[0].strip()):
                alldata += int(line.split()[9])
            else:
                continue

    return alldata

def network_outing_bytes_rate_inband():

    procinfo1 = readproc()
    time.sleep(SLEEPTIME)
    procinfo2 = readproc()
    if procinfo2 < procinfo1:
        return 0

    #rate(unit = KB/s)
    rate = ( procinfo2 - procinfo1 ) / float(SLEEPTIME) / 1024 * 8

    return round(rate, 2)

if __name__ =='__main__':
   print(network_outing_bytes_rate_inband())
